<?php
/*
Part of WordPress Plugin: Moderate Selected Posts
http://sivel.net/wordpress/
*/

$msp_version = '1.1';

// check the version in the options table and if less than this version perform update
function msp_ver_check () {
	global $msp_version;
	if ( ( msp_get_opt ( 'version' ) < $msp_version ) || ( !msp_get_opt ( 'version' ) ) ) :
		$msp_options = array ();
		$msp_options['version'] = $msp_version;
		$msp_options['posts'] = msp_get_opt ( 'posts' );
		msp_delete ();
		add_option ( 'msp_options' , $msp_options , 'Moderate Selected Posts Options' );
	endif;
}

// initialize the default options during plugin activation
function msp_init () {
	global $msp_version;
	if ( ! msp_get_opt ( 'version' ) ) :
	        $msp_options = array ();
		$msp_options['version'] = $msp_version;
	        $msp_options['posts'] = array();
	        add_option ( 'msp_options' , $msp_options , 'Moderate Selected Posts Options' ) ;
	else :
		msp_ver_check ();
	endif;
}

// delete all options 
function msp_delete () {
        delete_option ( 'msp_options' );
}

// add the options page
function msp_options_page () {
	if ( is_admin () ) :
	        if ( function_exists ( 'add_options_page' ) ) :
	                add_options_page ( 'Moderate Selected Pages' , 'Moderate Selected Posts' , 'manage_options' , 'moderate-selected-posts/moderate-selected-posts.php' , 'msp_admin_page' );
	        endif;
	endif;
}

// the options page
function msp_admin_page () {
	if ( is_admin () ) :
		msp_ver_check ();
		if ( $_POST['submit'] ) :
			$post_ids_post_arr = $_POST['post_id'];
			$msp_options['posts'] = $post_ids_post_arr;
			$msp_options['version'] = msp_get_opt ( 'version' );
			update_option ( 'msp_options' , $msp_options );
		endif;
		$post_ids_opt_arr = msp_get_opt ( 'posts' );
		if ( $post_ids_post_arr )
			$post_ids = array_merge ( $post_ids_opt_arr , $post_ids_post_arr );
		else
		        $post_ids = $post_ids_opt_arr;
		echo '<div class="wrap">' . "\r\n";
                echo '<h2>Moderate Selected Posts Options</h2>' . "\r\n";
		echo '<h3>Select the Posts you wish to moderate all comments on:</h3>' . "\r\n";
		echo '<form action="' . $_SERVER['REQUEST_URI'] . '" method="post">' . "\r\n";
	        $avail_posts = get_posts ( 'numberposts=-1' );
	        $avail_posts_cnt = count ( $avail_posts );
	        $i = $avail_posts_cnt;
		while ( $i > 0 ) :
			$i--;
			$msp_post_id = $avail_posts[$i]->ID;	
			$msp_post_title = $avail_posts[$i]->post_title;
			if ( $post_ids ) :
				if ( in_array ( $msp_post_id , $post_ids ) ) :
					$post_checked = ' checked="checked" ';
				else :
					$post_checked = '';
				endif;
			endif;
			echo '<input type="checkbox" name="post_id[]" value="' . $msp_post_id  . '"' . $post_checked . ' />' . $msp_post_title  . '<br />' . "\r\n";
		endwhile;
		echo '<input type="submit" name="submit" class="button" value="Submit" />&nbsp;&nbsp;';
		echo '<input type="reset" name="reset" class="button" value="Reset" />&nbsp;&nbsp;';
		echo '<input type="button" name="cancel" value="Cancel" class="button" onclick="javascript:history.go(-1)" />' . "\r\n";
		echo '</form>' . "\r\n";
		echo '</div>' . "\r\n";
	endif;
}

// add actions for plugin activation and for the options page
add_action ( 'admin_menu' , 'msp_options_page' ) ;
add_action ( 'activate_moderate-selected-posts/moderate-selected-posts.php' , 'msp_init' );
?>
